package jp.co.dreamarts.hibiki.smartdb.sample.ajaxapi;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.dreamarts.hibiki.smartdb.api.APIDocument;
import jp.co.dreamarts.hibiki.smartdb.api.BinderManager;
import jp.co.dreamarts.hibiki.smartdb.api.DocumentManager;
import jp.co.dreamarts.hibiki.smartdb.api.DocumentSearchCondition;
import jp.co.dreamarts.hibiki.smartdb.api.SmartdbAPI;
import jp.co.dreamarts.hibiki.soap.smartdb.MatchMode;

import org.apache.commons.logging.Log;

public class GetProduct {

    public String getCategoryName(SmartdbAPI api, Log log, HttpServletRequest request,
            HttpServletResponse response) throws Exception {
        String binderKey = request.getParameter("binderKey");
        String categoryCode = request.getParameter("categoryCode");
        if (categoryCode == null)
            throw new Exception("カテゴリコードを指定してください");
        DocumentManager dman = api.getDocumentManager();
        DocumentSearchCondition searchCondition = dman.createDocumentSearchCondition();
        BinderManager bman = api.getBinderManager();
        long binderId = bman.findBinderIdByKey(binderKey);
        searchCondition.withBinderId(binderId).withText("categoryCode", MatchMode.SUBSTRING, categoryCode);
        // ソートなし、1件だけ取得
        List<APIDocument> results = dman.getSearchResult(searchCondition, null, 0, 1);
        if (results != null && results.size() == 1)
            return results.get(0).getText("categoryName");
        return null;
    }

    // if you want JSON at client side, return Map
    public Map<?, ?> getProduct(SmartdbAPI api, Log log, HttpServletRequest request,
            HttpServletResponse response) throws Exception {
        String binderKey = request.getParameter("binderKey");
        String categoryCode = request.getParameter("categoryCode");
        String productCode = request.getParameter("productCode");
        if (categoryCode == null)
            throw new Exception("カテゴリコードを指定してください");
        if (productCode == null)
            throw new Exception("商品コードを指定してください");
        DocumentManager dman = api.getDocumentManager();
        DocumentSearchCondition searchCondition = dman.createDocumentSearchCondition();
        BinderManager bman = api.getBinderManager();
        long binderId = bman.findBinderIdByKey(binderKey);
        searchCondition.withBinderId(binderId).withText("categoryCode", MatchMode.SUBSTRING, categoryCode)
                .withText("productCode", MatchMode.SUBSTRING, productCode);
        // ソートなし、1件だけ取得
        List<APIDocument> results = dman.getSearchResult(searchCondition, null, 0, 1);
        if (results != null && results.size() == 1) {
            APIDocument doc = results.get(0);
            Map<String, String> map = new HashMap<String, String>(2);
            map.put("categoryName", doc.getText("categoryName"));
            map.put("productName", doc.getText("productName"));
            return map;
        }
        return null;
    }
}
