package jp.co.dreamarts.hibiki.smartdb.sample.buttoncustom.docview;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.dreamarts.hibiki.api.common.account.Account;
import jp.co.dreamarts.hibiki.smartdb.api.APIDocument;
import jp.co.dreamarts.hibiki.smartdb.api.SmartdbAPI;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class DocReadAction extends Action {

    @Override
    public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request,
            HttpServletResponse response) throws Exception {
        DocReadForm dform = (DocReadForm) form;
        /* この方法でもいいです。
        //ユーザ
        Account user = SmartdbAPI.getAccount(dform.getMid());

        // APIを取得
        SmartdbAPI api = new SmartdbAPI(APIFactoryType.Server, user);
        */

        //この方法では、よく使えます。
        //APIを取得
        SmartdbAPI api = SmartdbAPI.getServerSmartdbAPI();

        //ユーザ
        Account user = api.getSessionUser();

        // 文書ロード
        APIDocument doc = api.loadDocument(dform.getBinId(), dform.getRecId());

        if (ActionButtonCustomExtensionPointsSample.DOC_READ_ITEM_TYPE.equals(doc
                .getItemType(ActionButtonCustomExtensionPointsSample.DOC_READ_ITEM_KEY))) {
            //　既読済みかを判断
            boolean hasRead = false;
            List<Account> accountList = doc
                    .getAccountList(ActionButtonCustomExtensionPointsSample.DOC_READ_ITEM_KEY);
            for (Account account : accountList) {
                if (account.getId() == user.getId())
                    hasRead = true;
            }

            if (!hasRead) {
                // 既読情報を更新
                accountList.add(user);
                doc.setAccountList(ActionButtonCustomExtensionPointsSample.DOC_READ_ITEM_KEY, accountList);
                api.saveDocument(doc);
            }

        }

        return null;
    }

}
