package jp.co.dreamarts.hibiki.smartdb.sample.hookpoints.validator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.dreamarts.hibiki.smartdb.api.APIDocument;
import jp.co.dreamarts.hibiki.smartdb.api.SmartdbAPI;
import jp.co.dreamarts.hibiki.smartdb.hookpoints.DocumentActionHookPoints;
import jp.co.dreamarts.hibiki.smartdb.hookpoints.ReturnType;
/**
 *CustomValidatorのsampleプログラム
 *
 * @author okamoto
 *
 */

public class APICustomValidator extends DocumentActionHookPoints {

    private SmartdbAPI api;

    public APICustomValidator(SmartdbAPI api) {
        this.api = api;
    }

    @Override
    public ReturnType beforeInsert(HttpServletRequest request, HttpServletResponse response, APIDocument doc) {
        String key = "message.binder.customValidator.notExpected";
        String key2 = "message.binder.customValidator.notExpected2";
        String bundle = "Sample";
        String str;
        try {
            str = doc.getText(10002);
            if (str == null || str.length() == 0) {
                addErrorForDisplay(key2, bundle, new Object[] { "10002" });
                return ReturnType.ERROR;
            } else if (str.indexOf('あ') < 0) {
                addErrorForDisplay(key, bundle, new Object[] { "あ" });
                return ReturnType.ERROR;
            }
        } catch (Exception e) {
            // 画面表示用のメッセージを設定する
            addErrorForDisplay(key, bundle, new Object[] { "部品番号=10002の部品が存在しません。" });
            // 予め用意されたlogでログ出力を行う
            log.error("MyHookPoints：部品10002が見つかりません。");
            return ReturnType.EXCEPTION;
        }

        return ReturnType.DECLINED;

    }

    @Override
    public ReturnType beforeUpdate(HttpServletRequest request, HttpServletResponse response, APIDocument doc,
            APIDocument oldDoc) {
        // TODO 自動生成されたメソッド・スタブ
        String key = "message.binder.customValidator.notExpected";
        String key2 = "message.binder.customValidator.notExpected2";
        String bundle = "Sample";
        String str;
        ReturnType ret = ReturnType.DECLINED;
        try {
            str = doc.getText(10002);
            if (str == null || str.length() == 0) {
                addErrorForDisplay(key2, bundle, new Object[] { "10002" });
                ret = ReturnType.ERROR;
            } else if (str.indexOf('あ') < 0) {
                //addErrorForDisplay(key, bundle, new Object[] { "あ" });
                return ReturnType.ERROR;
            }
        } catch (Exception e) {
            // 画面表示用のメッセージを設定する
            addErrorForDisplay(key, bundle, new Object[] { "部品番号=10002の部品が存在しません。" });
            // 予め用意されたlogでログ出力を行う
            log.error("MyHookPoints：部品10002が見つかりません。");
            return ReturnType.EXCEPTION;
        }

        return ret;

    }

    @Override
    public SmartdbAPI getAPI() {
        return api;
    }

}
