## 概要

REST APIを利用し、バインダ一覧から任意のバインダの文書一覧を表示するサンプルです。<br>
REST APIにてSm@rtDBへログインし、Sm@rtDBからバインダ一覧をブラウザに表示させます。
表示されたバインダ一覧から任意のバインダの文書一覧の表示させ、Sm@rtDBの文書閲覧画面に遷移します。

## 使用しているアドオン方式

REST API<br>
    HTTPを使った通信で外部アプリケーションからSm@rtDB内にあるバインダ、文書などの情報を参照、登録・更新、削除するための API です。

## 実際のソースコード

サンプルプログラムの関連ファイルは以下の内容になっています（HTMLの内容）。<br>
※本サンプルプログラムはREST API Ver.2を利用しています。<br>

REAT APIのHTML RESTクライアントが記載されているファイル<br>
　REST_API_sample.html<br>

以下のファイルはプログラムではなく、バインダ定義のサンプルです。<br>
　restapi-binder-sample.zip<br>
　restapi-main-sample.csv<br>

## 適用手順

1. REST_API_sample.htmlをサーバ上に配置します。<br>　
配置先：/opt/jakarta-tomcat/webapps/hibiki/<br>

2. バインダを用意します。<br>　
付属のrestapi-binder-sample.zipを使用して、バインダ定義情報のインポートを行います。<br>　
テスト用のデータは付属のrestapi-main-sample.csvを使用して、restapi-binder-sample.zipを適用したバインダにCSV入力してください。<br>

## 動作確認

1. ブラウザからhttp://yourSite/hibiki/REST_API_sample.html にアクセスします。  
ブラウザに下図のような画面が表示されることと、Smrt＠DBへのログイン成功のアラートを確認します。
 ![動作確認1](../../images/8_2_2-01.png)

2. 実際の動作を確認します。<br>
(ア)ブラウザに表示された画面からバインダ一覧表示ボタンをクリックし、Sm@rtDBに登録されているバインダの一覧を取得します。<br>
(イ)バインダ一覧にrestapi-binder-sample.zipを適用したバインダが表示されるのを確認し、バインダIDをクリックして文書一覧を表示させます。<br>
(ウ)文書一覧から任意の文書の文書番号をクリックし、Sm@rtDBの文書閲覧画面に遷移することを確認します。<br>

